# -*- coding: utf-8 -*-

from math import dist

from Model.Geometry.Point import Point

class PointAC(Point):
    def __init__(self, a:float = 0.0, c:float = 0.0,
                 name: str = ""):
        super(PointXY, self).__init__(name = name)

        self._a = float(a)
        self._c = float(c)

    def __repr__(self):
        return f"[{self._a}, {self._c}, {self._name}]"

    @property
    def a(self):
        return self._a

    @a.setter
    def a(self, value):
        self._a = float(value)

    @property
    def c(self):
        return self._c

    @c.setter
    def c(self, value):
        self._c = float(value)

    def dist(self, p2):
        return PointAC.distance(self, p2)

    @staticmethod
    def distance(p1, p2):
        """Euclidean distance between p1 and p2.

        Args:
            p1: A AC Point
            p2: A AC Point

        Returns:
            Euclidean distance between the two points
        """
        return dist((p1.a, p1.c), (p2.a, p2.c))
